﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace netvis
{
    class AggregateTimeSpan : TimeSpan
    {

        protected SortedList<DateTime, TimeSpan> children = new SortedList<DateTime, TimeSpan>();
        public SortedList<DateTime, TimeSpan> subtress
        {
            get { return children; }
        }
        public override List<Packet> getAllPackets()
        {
            List<Packet> list = new List<Packet>();
            foreach (TimeSpan node in children.Values)
            {
                list.AddRange(node.getAllPackets());
            }
            return list;
        }
        public override DateTime findEarliest()
        {
            if (children.Count > 0)
            {
                return children.Values[0].findEarliest();
            }
            return DateTime.MaxValue;
        }
        public override SortedList<DateTime, TimeSpan> getSubtress() {
            return subtress;
        }
        public override DateTime findLatest()
        {
            if (children.Count > 0)
            {
                return children.Values[children.Count - 1].findLatest();
            }
            return DateTime.MinValue;
        }
        public override void add(Packet child)
        {
            
        }
    }
}
